class ELLIPSE
inherit ANY 
insert MATH_CONSTANTS export {} all end
create{ANY}
  with_axes, 
  with_foci_semidistance_and_eccentricity
feature {ANY}
  perimeter: REAL 
    -- Implemented using a Ramanujan's approximation https://en.wikipedia.org/wiki/Perimeter_of_an_ellipse
  do
    Result := Pi * (3 * (a+b) - ((3*a+b)*(a+3*b)).sqrt)
  end

  a: REAL -- major semiaxis
  b: REAL -- minor semiaxis

feature {ANY}
  set_a (a_value: REAL) assign a do a:=a_value end 
  set_b (a_value: REAL) assign b do b:=a_value end 
feature {ANY}
  with_axes (major,minor: like a) 
  require major>minor 
  do
    a := major/2
    b := minor/2
  end
  with_foci_semidistance_and_eccentricity (c, e: REAL)
    require 
      meaningful_foci_semidistnace: c>0
      meaningful_eccentricity: e>0
    do
      a := c/e
      b := (a^2-c^2).sqrt
    end
    -- set foci at (-an_x, 0) and (an_x, 0) and 
  -- default_create do
  --   a:=5; b:=3
  -- end
end 

